'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'Calendar_init PART 1
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'***************************************
'***************************************
'Save this file as Calendar_Init.bas
'***************************************
'***************************************
'***************************************
'Written in freebasic for windows ver 2.0
'***************************************
'***************************************
'***************************************
#define WIN_INCLUDEALL
#Include "windows.bi"
#include "vbcompat.bi"

declare sub load_holidays()
declare sub load_work_times()
declare sub load_appointment_length()
declare sub initialize_calendar_year(init_year as string)
declare sub print_to_database(entries as string)

declare sub month1(init_year as string) 'january
declare sub month2(init_year as string) 'febuary
declare sub month3(init_year as string) 'march
declare sub month4(init_year as string) 'april
declare sub month5(init_year as string) 'may
declare sub month6(init_year as string) 'june
declare sub month7(init_year as string) 'july
declare sub month8(init_year as string) 'august
declare sub month9(init_year as string) 'september
declare sub month10(init_year as string) 'ovtober
declare sub month11(init_year as string) 'november
declare sub month12(init_year as string) 'december

dim shared as string file
dim shared as integer years1 , months1, days1
dim shared as integer years ,months , days
dim shared as string dates
dim shared as string help_text
dim shared as string generic_txt,str1

dim shared as string init_year
dim shared as string selected_year

dim shared as integer time_slot_length
dim shared as integer line_number

dim shared as integer place

'create messaging and controls
'===============================================================================
'===============================================================================
Dim As MSG msg
Dim shared As HWND hWnd, holidays , holidays_txt , holidays_info , save_holidays , _
                            sun, sun_start , sun_lunch , sun_lunch_over , sun_finish , _
                            mon, mon_start , mon_lunch , mon_lunch_over , mon_finish , _
                            tue, tue_start , tue_lunch , tue_lunch_over , tue_finish , _
                            wed, wed_start , wed_lunch , wed_lunch_over , wed_finish , _
                            thu, thu_start , thu_lunch , thu_lunch_over , thu_finish , _
                            fri, fri_start , fri_lunch , fri_lunch_over , fri_finish , _
                            sat, sat_start , sat_lunch , sat_lunch_over , sat_finish , work_times_save ,work_times_info , _
                            time_slots , time_slots_length , time_slots_save , time_slots_info , _
                            initialize_year , initialize_calendar

' Create window
hWnd = CreateWindowEx( 0, "#32770", "Calendar Initilaizer 1.0 by Albert Redditt Jan,2011", WS_OVERLAPPEDWINDOW Or WS_VISIBLE , 100, 100, 1024, 450, 0, 0, 0, 0 )

'setup gadgets for holidays
holidays     = CreateWindowEx( 0, "EDIT"  ,  "  !!~~ HOLIDAYS ~~!!  " , _
                                 WS_BORDER Or _
                                 WS_VISIBLE Or _
                                 WS_CHILD   OR _
                                 ES_READONLY , _
                                 10, 10, 140, 25, hWnd, 0, 0, 0 )
holidays_txt = CreateWindowEx( 0, "EDIT"  ,  ""                                   , _
                                 WS_border Or _
                                 WS_VISIBLE Or _
                                 WS_CHILD Or   _
                                 WS_HSCROLL Or _
                                 WS_VSCROLL Or _
                                 ES_AUTOHSCROLL Or _
                                 ES_AUTOVSCROLL Or _
                                 ES_MULTILINE, _
                                 10, 40, 350, 330, hWnd, 0, 0, 0 )

holidays_info = CreateWindowEx( 0, "BUTTON", "INFO"          , WS_VISIBLE Or WS_CHILD, 160, 10 ,70, 25, hWnd, 0, 0, 0 )
save_holidays = CreateWindowEx( 0, "BUTTON", "Save Holidays" , WS_VISIBLE Or WS_CHILD, 240, 10 ,100, 25, hWnd, 0, 0, 0 )
'===============================================================================
'setup gadgets for work times
sun = CreateWindowEx( 0, "EDIT"  , "   Sun" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,375,10, 60, 25, hWnd, 0, 0, 0 )
mon = CreateWindowEx( 0, "EDIT"  , "   Mon" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,450,10, 60, 25, hWnd, 0, 0, 0 )
tue = CreateWindowEx( 0, "EDIT"  , "   Tue" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,525,10, 60, 25, hWnd, 0, 0, 0 )
wed = CreateWindowEx( 0, "EDIT"  , "   Wed" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,600,10, 60, 25, hWnd, 0, 0, 0 )
thu = CreateWindowEx( 0, "EDIT"  , "   Thu" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,675,10, 60, 25, hWnd, 0, 0, 0 )
fri = CreateWindowEx( 0, "EDIT"  , "   Fri" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,750,10, 60, 25, hWnd, 0, 0, 0 )
sat = CreateWindowEx( 0, "EDIT"  , "   Sat" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,825,10, 60, 25, hWnd, 0, 0, 0 )


work_times_save = CreateWindowEx( 0, "BUTTON"  , "SAVE" , WS_BORDER Or WS_VISIBLE Or WS_CHILD,900,10, 70, 25, hWnd, 0, 0, 0 )
work_times_info = CreateWindowEx( 0, "BUTTON"  , "INFO" , WS_BORDER Or WS_VISIBLE Or WS_CHILD,900,50, 70, 25, hWnd, 0, 0, 0 )

sun_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,375,50, 62, 25, hWnd, 0, 0, 0 )
mon_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,450,50, 62, 25, hWnd, 0, 0, 0 )
tue_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,525,50, 62, 25, hWnd, 0, 0, 0 )
wed_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,600,50, 62, 25, hWnd, 0, 0, 0 )
thu_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,675,50, 62, 25, hWnd, 0, 0, 0 )
fri_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,750,50, 62, 25, hWnd, 0, 0, 0 )
sat_start = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,825,50, 62, 25, hWnd, 0, 0, 0 )

sun_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,375,90, 62, 25, hWnd, 0, 0, 0 )
mon_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,450,90, 62, 25, hWnd, 0, 0, 0 )
tue_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,525,90, 62, 25, hWnd, 0, 0, 0 )
wed_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,600,90, 62, 25, hWnd, 0, 0, 0 )
thu_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,675,90, 62, 25, hWnd, 0, 0, 0 )
fri_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,750,90, 62, 25, hWnd, 0, 0, 0 )
sat_lunch = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,825,90, 62, 25, hWnd, 0, 0, 0 )

sun_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,375,130, 62, 25, hWnd, 0, 0, 0 )
mon_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,450,130, 62, 25, hWnd, 0, 0, 0 )
tue_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,525,130, 62, 25, hWnd, 0, 0, 0 )
wed_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,600,130, 62, 25, hWnd, 0, 0, 0 )
thu_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,675,130, 62, 25, hWnd, 0, 0, 0 )
fri_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,750,130, 62, 25, hWnd, 0, 0, 0 )
sat_lunch_over = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,825,130, 62, 25, hWnd, 0, 0, 0 )

sun_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,375,170, 62, 25, hWnd, 0, 0, 0 )
mon_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,450,170, 62, 25, hWnd, 0, 0, 0 )
tue_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,525,170, 62, 25, hWnd, 0, 0, 0 )
wed_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,600,170, 62, 25, hWnd, 0, 0, 0 )
thu_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,675,170, 62, 25, hWnd, 0, 0, 0 )
fri_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,750,170, 62, 25, hWnd, 0, 0, 0 )
sat_finish = CreateWindowEx( 0, "EDIT"  , "" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,825,170, 62, 25, hWnd, 0, 0, 0 )

time_slots        = CreateWindowEx( 0, "EDIT"  , "Time Slots ( Length in Minutes )" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,375,250,220, 25, hWnd, 0, 0, 0 )
time_slots_length = CreateWindowEx( 0, "EDIT"  , "30"                               , WS_BORDER Or WS_VISIBLE Or WS_CHILD               ,600,250, 35, 25, hWnd, 0, 0, 0 )
time_slots_save   = CreateWindowEx( 0, "BUTTON", "SAVE"                             , WS_BORDER Or WS_VISIBLE Or WS_CHILD               ,720,250, 70, 25, hWnd, 0, 0, 0 )
time_slots_info   = CreateWindowEx( 0, "BUTTON", "INFO"                             , WS_BORDER Or WS_VISIBLE Or WS_CHILD               ,640,250, 70, 25, hWnd, 0, 0, 0 )

initialize_year     = CreateWindowEx( 0, "EDIT"  , "2011"                     , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,525,300, 40, 25, hWnd, 0, 0, 0 )
initialize_calendar = CreateWindowEx( 0, "BUTTON", "INITIALIZE CALENDAR YEAR" , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,575,300,200, 25, hWnd, 0, 0, 0 )

load_work_times()
load_holidays()
load_appointment_length()

'===============================================================================
'begin message loop
'===============================================================================
'===============================================================================
While GetMessage( @msg, 0, 0, 0 )
    TranslateMessage( @msg )
    DispatchMessage( @msg )
    
    Select Case msg.hwnd
        Case hWnd
        Select Case msg.message
            Case 273
            End
        End Select

    case holidays_info
        select case msg.message
            case WM_LBUTTONDOWN
                dim as hWnd holiday 
                help_text = "See the U.S. GOV. !!~HOLIDAY~!! chart, " +chr(13)+chr(10)
                help_text+= "from the following federal schedule.   " +chr(13)+chr(10)
                help_text+= "                                       " +chr(13)+chr(10)
                help_text+= "                                       " +chr(13)+chr(10)
                help_text+= "http://www.opm.gov/Operating_Status_Schedules/fedhol/2011.asp" + chr(13)+chr(10)
                help_text+= "                                       "   +chr(13)+chr(10)
                help_text+= "http://www.opm.gov/Operating_Status_Schedules/fedhol/2012.asp" + chr(13)+chr(10)
                help_text+= "                                       "   +chr(13)+chr(10)
                help_text+= "Then add your own days off.            "   +chr(13)+chr(10)
                help_text+= "                                       "   +chr(13)+chr(10)
                help_text+= "Enter abbreviated Day name, SUN MON TUE ect..   "   +chr(13)+chr(10)
                help_text+= "Enter abbreviated Month Name JAN FEB MAR etc..  " +chr(13)+chr(10)
                help_text+= "Enter day number 1 17 24  etc              "   +chr(13)+chr(10)
                help_text+= "Separate dayname , month , date by an UNDERSCORE." +chr(13)+chr(10)
                help_text+= "                                           " +chr(13)+chr(10)
                help_text+= "MON_JAN_17                                 " +chr(13)+chr(10)
                help_text+= "MON_FEB_21  _under line before notes.      " +chr(13)+chr(10)
                help_text+= "MON_FEB_14_Valentines day                  " +chr(13)+chr(10)
                help_text+= "MON_FEB_21_Presidents day                  " +chr(13)+chr(10)
                help_text+= "if the day is 0 to 9 put a zero in front of the daynumber" +chr(13)+chr(10)
                help_text+= "MON_JUL_04_Independance day                " +chr(13)+chr(10)
                help_text+= "                                           " +chr(13)+chr(10)
                help_text+= "Preceed abbreviated dayname with an UNDERSCORE for weekly occurances." +chr(13)+chr(10)
                help_text+= "_SAT                                  " +chr(13)+chr(10)
                help_text+= "_SUN                                  " +chr(13)+chr(10)
                help_text+= "_WED                                  " +chr(13)+chr(10)

                holiday = CreateWindowEx( 0, "EDIT", "HOLIDAY INSTRUCTIONS", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 800, 480, 0, 0, 0, 0 )
                SetWindowText(holiday,help_text)
        end select
    
    case work_times_info
        select case msg.message
            case WM_LBUTTONDOWN
                dim as hWnd work_times 
                help_text = "Enter work/available times into the grid," +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "Day Start                                " +chr(13)+chr(10)
                help_text+= "Lunch                                    " +chr(13)+chr(10)
                help_text+= "Lunch Over                               " +chr(13)+chr(10)
                help_text+= "End of Day                               " + chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "Enter times for each day.                " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "Times must be in 24Hr format:            " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "01:00PM = 13:00    2:00PM = 14:00    3:00PM = 15:00 " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "04:00PM = 16:00    5:00PM = 17:00    6:00PM = 18:00 " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "07:00PM = 19:00    8:00PM = 20:00    9:00PM = 21:00 " +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "10:00PM = 22:00   11:00PM = 23:00   12:00PM = 24:00 " +chr(13)+chr(10)
                
                work_times = CreateWindowEx( 0, "EDIT", "Work Info", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 600, 480, 0, 0, 0, 0 )
                SetWindowText(work_times,help_text)
        end select
    
    case time_slots_info
        select case msg.message
            case WM_LBUTTONDOWN
                dim as hWnd time_slots 
                help_text = "Enter length of expected appointments / engagements." +chr(13)+chr(10)
                help_text+= "The value you enter determines the overall time slot allocation." +chr(13)+chr(10)
                help_text+= "                                         " +chr(13)+chr(10)
                help_text+= "The directory day will be cut into slots of this length." +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "you can always book several slots to an appointment" + chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "The default is 30 minute slots.           " +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "Valid values are:                         " +chr(13)+chr(10)
                help_text+= "15 , 30 , 45 , 60 , 75 , 90 , 120         " +chr(13)+chr(10)
                help_text+= "values outside this will be approximated to the nearest 15" +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= " IMPORTANT : save the Time Slot Length    " +chr(13)+chr(10)
                help_text+= " Before clicking 'INTIIALIZE CALENDAR'    " +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "Save WorkDays and holidays after Initializing calendar year." +chr(13)+chr(10)
                help_text+= "                                          " +chr(13)+chr(10)
                help_text+= "Holidays.ini     needs to be in the yearly directory." +chr(13)+chr(10)
                help_text+= "Work_Times.ini   needs to be in the yearly directory." +chr(13)+chr(10)
                help_text+= "Appointments.ini needs to be in the Calendar directory." +chr(13)+chr(10)

                time_slots = CreateWindowEx( 0, "EDIT", "Work Info", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 800, 480, 0, 0, 0, 0 )
                SetWindowText(time_slots,help_text)
        end select

    case initialize_calendar
        select case msg.message
            case WM_LBUTTONDOWN
                init_year="     "
                getWindowText(initialize_year , init_year , 5)
                init_year = trim(init_year," ")
                initialize_calendar_year( init_year )
                load_holidays()
                load_work_times()
        end select
        
    case save_holidays
        select case msg.message
        case WM_LBUTTONDOWN
                init_year="     "
                getWindowText(initialize_year , init_year , 5)
                init_year = trim(init_year," ")
                open curdir + "\" + init_year + "\Holidays.ini" for output as #1
                    generic_txt = space(GetWindowTextLength(holidays_txt))
                    GetWindowText(holidays_txt , generic_txt , sizeof(generic_txt)+10000)
                    print generic_txt
                    print #1,generic_txt
                close #1
        end select    
    
    case time_slots_save
        select case msg.message
        case WM_LBUTTONDOWN
            open curdir + "\Appointments.ini" for output as #1
                generic_txt = "    "
                GetWindowText(time_slots_length , generic_txt , 4)
                generic_txt=trim(generic_txt," ")
                print #1,generic_txt
            close #1
        end select    
    
    case work_times_save
        select case msg.message
        case WM_LBUTTONDOWN
            init_year="     "
            getWindowText(initialize_year , init_year , 5)
            init_year = trim(init_year," ")
            open curdir + "\" + init_year + "\Work_Times.ini" for output as #1
            
                'sunday
                print #1, "SUNDAY"
                generic_txt = "        "
                GetWindowText(sun_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sun_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sun_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sun_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                'monday
                print #1, "MONDAY"
                generic_txt = "        "
                GetWindowText(mon_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(mon_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(mon_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(mon_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt

                'tuesday
                print #1, "TUESDAY"
                generic_txt = "        "
                GetWindowText(tue_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(tue_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(tue_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(tue_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt

                'wednesday
                print #1, "WEDNESDAY"
                generic_txt = "        "
                GetWindowText(wed_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(wed_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(wed_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(wed_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                'thursday
                print #1, "THURSDAY"
                generic_txt = "        "
                GetWindowText(thu_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(thu_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(thu_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(thu_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                'friday
                print #1, "FRIDAY"
                generic_txt = "        "
                GetWindowText(fri_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
                
                generic_txt = "        "
                GetWindowText(fri_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
                
                generic_txt = "        "
                GetWindowText(fri_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(fri_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                'saturday
                print #1, "SATURDAY"
                generic_txt = "        "
                GetWindowText(sat_start , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sat_lunch , generic_txt , 8 )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sat_lunch_over , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
                generic_txt = "        "
                GetWindowText(sat_finish , generic_txt , 8  )
                generic_txt=trim(generic_txt," ")
                print #1 , generic_txt
            
            close #1
        end select
    
    End select
    
Wend
'===============================================================================
'===============================================================================
sleep
END'of program
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'Calendar_Init part 2
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
sub load_holidays()
    
    init_year="     "
    getWindowText(initialize_year , init_year , 5)
    init_year = trim(init_year," ")
    
    file = curdir + "\" + init_year + "\Holidays.ini"
    if FileExists(file) then
        open file for input as #1
            str1=""
            do    
                line input #1,generic_txt
                str1+=generic_txt + chr(13)+chr(10)
            loop until eof(1)
            SetWindowText(holidays_txt,str1)
        close #1
        str1=""
        generic_txt=""
    end if
end sub
'===============================================================================
'===============================================================================
sub load_work_times()
    
    init_year="     "
    getWindowText(initialize_year , init_year , 5)
    init_year = trim(init_year," ")
    
    file = curdir + "\" + init_year + "\Work_Times.ini"
    if FileExists(file) then
        open file for input as #1
            generic_txt=""
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(sun_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(sun_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(sun_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(sun_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(mon_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(mon_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(mon_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(mon_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(tue_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(tue_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(tue_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(tue_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(wed_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(wed_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(wed_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(wed_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(thu_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(thu_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(thu_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(thu_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(fri_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(fri_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(fri_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(fri_finish     ,generic_txt)
            
            line input #1,generic_txt : print generic_txt
            line input #1,generic_txt : SetWindowText(sat_start      ,generic_txt)
            line input #1,generic_txt : SetWindowText(sat_lunch      ,generic_txt)
            line input #1,generic_txt : SetWindowText(sat_lunch_over ,generic_txt)
            line input #1,generic_txt : SetWindowText(sat_finish     ,generic_txt)
            
            close #1
        generic_txt=""
    end if
end sub
'===============================================================================
'===============================================================================
sub load_appointment_length()
    open curdir + "\Appointments.ini" for input as #1
        line input #1 , generic_txt
        SetWindowText(time_slots_length , generic_txt)
    close #1
end sub
'===============================================================================
'===============================================================================
'create yearly directory structure
'===============================================================================
'===============================================================================
sub initialize_calendar_year(init_year as string)
    
    open curdir + "\Appointments.ini" for input as #1
        line input #1, generic_txt
    close #1
    time_slot_length = val(generic_txt)
    
    if time_slot_length >=1  and time_slot_length <=15 then time_slot_length=15
    if time_slot_length >=16 and time_slot_length <=30 then time_slot_length=30
    if time_slot_length >=31 and time_slot_length <=45 then time_slot_length=45
    if time_slot_length >=46 and time_slot_length <=60 then time_slot_length=60
    
    if time_slot_length >=61 and time_slot_length <=75 then time_slot_length=75
    if time_slot_length >=76 and time_slot_length <=90 then time_slot_length=90
    if time_slot_length >=91 and time_slot_length <=120 then time_slot_length=120
    
    
    file=curdir + "\Initialized.txt"
    
    open file for input as #1
    do
        line input #1 , generic_txt
        if generic_txt = init_year then 
            close #1
            help_text = str(init_year) + chr(13)+chr(10)
            help_text+= "                                                   " + chr(13)+chr(10)
            help_text+= "Has already been initialized.                      " + chr(13)+chr(10)
            help_text+= "                                                   " + chr(13)+chr(10)
            help_text+= "To reinitialize  " + str(init_year)                  + chr(13)+chr(10)
            help_text+= "Open Windows Explorer and delete the calendar year." + chr(13)+chr(10)
            help_text+= "Then open 'Initialized.txt' and remove the year.   " + chr(13)+chr(10)
            help_text+= "The Calendar year is in the following directory:   " + chr(13)+chr(10)
            help_text+= curdir + "\"                                          + chr(13)+chr(10)

            MessageBox(0, help_text , 0 , MB_OK)
            return
        end if
    loop until eof(1)
    close #1
    
    open file for append as #1
        print #1,init_year
    close #1
    
        file=curdir + "\"+ init_year
        
        if not FileExists(file) then
            print "Creating initial directory structure."
            mkdir curdir + "\" + init_year
        else
            print "Calendar was previously initialized"
            return
        end if
        
        
        ' do january
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\JAN"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\JAN"
        open   curdir + "\" + init_year + "\JAN" + "\JAN_DATABASE.TXT" for output as #1
            month1(init_year)
        close #1
        
        ' do febuary
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\FEB"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\FEB"
        open   curdir + "\" + init_year + "\FEB" + "\FEB_DATABASE.TXT" for output as #1
            month2(init_year)
        close #1

        ' do march
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\MAR"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\MAR"
        open   curdir + "\" + init_year + "\MAR" + "\MAR_DATABASE.TXT" for output as #1
            month3(init_year)
        close #1
        
        ' do APRIL
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\APR"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\APR"
        open   curdir + "\" + init_year + "\APR" + "\APR_DATABASE.TXT" for output as #1
            month4(init_year)
        close #1

        ' do MAY
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\MAY"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\MAY"
        open   curdir + "\" + init_year + "\MAY" + "\MAY_DATABASE.TXT" for output as #1
            month5(init_year)
        close #1

        ' do JUNE
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\JUN"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\JUN"
        open   curdir + "\" + init_year + "\JUN" + "\JUN_DATABASE.TXT" for output as #1
            month6(init_year)
        close #1

        ' do JULY
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\JUL"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\JUL"
        open   curdir + "\" + init_year + "\JUL" + "\JUL_DATABASE.TXT" for output as #1
            month7(init_year)
        close #1

        ' do AUGUST
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\AUG"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\AUG"
        open   curdir + "\" + init_year + "\AUG" + "\AUG_DATABASE.TXT" for output as #1
            month8(init_year)
        close #1

        ' do SEPTEMBER
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\SEP"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\SEP"
        open   curdir + "\" + init_year + "\SEP" + "\SEP_DATABASE.TXT" for output as #1
            month9(init_year)
        close #1

        ' do OCTOBER
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\OCT"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\OCT"
        open   curdir + "\" + init_year + "\OCT" + "\OCT_DATABASE.TXT" for output as #1
            month10(init_year)
        close #1

        ' do NOVEMBER
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\NOV"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\NOV"
        open   curdir + "\" + init_year + "\NOV" + "\NOV_DATABASE.TXT" for output as #1
            month11(init_year)
        close #1

        ' do DECEMBER
        '-----------------------------------------------------------------------
        file = curdir + "\" + init_year + "\DEC"
        if not FileExists(file) then mkdir curdir + "\" + init_year + "\DEC"
        open   curdir + "\" + init_year + "\DEC" + "\DEC_DATABASE.TXT" for output as #1
            month12(init_year)
        close #1

        print "Finished Initializing directories and databases."
        
        help_text = "Finished initializing directories and databases. "                           + chr(13) + chr(10)
        help_text+= "Databese time slots have been set at " + str(time_slot_length) + " Minutes " + chr(13) + chr(10)
        
        MessageBox(0, help_text , 0,MB_OK)
end sub
'===============================================================================
'===============================================================================
sub print_to_database(entries as string)
    
    dim as single times = 60/time_slot_length
    dim as single hours
    dim as string time_hours
    dim as string time_minutes

    dim as integer hrs
    dim as integer mins
        
    dim as string str1
    dim as integer place
        
    hours= 0
    do
        str1=str(hours)
        place=instr(1,str1,".")
                
        if place<>0 then 
            time_hours = left(str1,place-1)
            time_minutes  =  mid(str1,place)
            if time_minutes = ".25" then time_minutes = "_15"
            if time_minutes = ".5"  then time_minutes = "_30"
            if time_minutes = ".75" then time_minutes = "_45"
        else
            time_hours = str1
            time_minutes = "_00"
        end if
            
        hrs=val(time_hours) 
        mins=val(time_minutes)
            
        time_hours = right("00" + time_hours,2) + time_minutes
    
        dim as integer slot_length = 109 - len(right("0000"+str(line_number),4)) - len("|") - (len(entries) +len( "_") + len( time_hours ) + len("~~"))
            
        print #1, right("0000"+str(line_number),4) + "|" + entries + "_" + time_hours + "~~" + string(slot_length,"_")
                
        line_number+=1
            
        hours+=1/times
            
    loop until hours>=24

end sub
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'Calendar_Init PART 3
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
sub month1(init_year as string) 'january

    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    dim as string entries
    
    years1  = val(init_year)
    months1 =(1)
    days1   =(1)
    
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,1,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
        
    next
    
end sub
'===============================================================================
'===============================================================================
sub month2(init_year as string)'feb
            
    dim as string leapyears
    dim as integer isleapyear=0
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 28
    
    if years1 Mod 4 = 0 And years1 Mod 100 <> 0 Or (years1 Mod 400 = 0) then isleapyear = 1

    if isleapyear then last_day=29
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,2,inc1)
            
        entries = left( ucase(WeekDayName(WeekDay(a))) ,3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
        
    next
    
end sub
'===============================================================================
'===============================================================================
sub month3(init_year as string)'mar

    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(3)
    days1   =(1)
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,3,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    
end sub
'===============================================================================
'===============================================================================
sub month4(init_year as string)'apr
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    
    years1  =val(init_year)
    months1 =(4)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,4,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    
    
end sub
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
sub month5(init_year as string)'may
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(5)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,5,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"

        print_to_database(entries)
    
    next
    

end sub
'===============================================================================
'===============================================================================
sub month6(init_year as string)'jun

    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    
    dim as integer line_number=0
    
    years1  =val(init_year)
    months1 =(6)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,6,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    

end sub
'===============================================================================
'===============================================================================
sub month7(init_year as string)'jul
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(7)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,7,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    

end sub
'===============================================================================
'===============================================================================
sub month8(init_year as string)'aug
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(8)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,8,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    
end sub
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
sub month9(init_year as string)'sep
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    
    years1  =val(init_year)
    months1 =(9)
    days1   =(1)
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,9,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    
    
end sub
'===============================================================================
'===============================================================================
sub month10(init_year as string)'oct
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(10)
    days1   =(1)
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,10,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"

        print_to_database(entries)

    next
    
    
end sub
'===============================================================================
'===============================================================================
sub month11(init_year as string)'nov
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    
    years1  =val(init_year)
    months1 =(11)
    days1   =(1)

    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,11,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"

        print_to_database(entries)
    
    next
    

end sub
'===============================================================================
'===============================================================================
sub month12(init_year as string)'dec
    
    dim as string entries
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    
    years1  =val(init_year)
    months1 =(12)
    days1   =(1)
    
    line_number = 1
    for inc1 as integer = 1 to last_day
        a= DateSerial(years1,12,inc1)
            
        entries = left(ucase(WeekDayName(WeekDay(a))),3) + "_" 
        entries+= left(Ucase(MONTHNAME(MONTH(a))),3) + "_" 
        entries+= right("00" + str(DAY(a)),2) + "_"
        entries+= str(year(a))+"_"
            
        print_to_database(entries)
    
    next
    
end sub
