'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'Calendar part 1
'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'=============================================== 
'*****************************
'*****************************
' Calendar Version 1.0
' written in:
' FreeBasic for windows
'
'http://www.freebasic.net
'*****************************
'*****************************
#define WIN_INCLUDEALL
#Include "windows.bi"
#include "vbcompat.bi"
'==============================================================================
'==============================================================================
function MakeFont( byval faceName as zstring ptr, _
                   byval pointSize as integer, _
                   byval weight as integer, _
                   byval italic as integer ) as HFONT

    dim as HDC hdcScreen
    dim as integer height, pixelsPerLogicalInchY

    hdcScreen = GetDC(0)
    pixelsPerLogicalInchY = GetDeviceCaps( hdcScreen, LOGPIXELSY )
    height = pointSize * pixelsPerLogicalInchY / 72

return CreateFont( height, _
                       0, _
                       NULL, _
                       NULL, _
                       weight, _
                       italic, _
                       NULL, _
                       NULL, _
                       DEFAULT_CHARSET, _
                       OUT_TT_PRECIS, _
                       CLIP_DEFAULT_PRECIS, _
                       PROOF_QUALITY, _
                       DEFAULT_PITCH or FF_DONTCARE, _
                       faceName )

end function
'==============================================================================
'==============================================================================
'==============================================================================
'==============================================================================
declare sub get_current_date()
declare sub get_selected_date()

declare sub start_up()
declare sub load_work_times()
declare sub load_holidays()
declare sub load_appointments()
declare sub load_agenda()
declare Sub parse_holidays()
declare sub update_time_and_date()

declare sub month1()
declare sub month2()
declare sub month3()
declare sub month4()

declare sub month5()
declare sub month6()
declare sub month7()
declare sub month8()

declare sub month9()
declare sub month10()
declare sub month11()
declare sub month12()

dim shared as integer current_hours
dim shared as integer current_minutes
dim shared as integer current_seconds

dim shared as double current_year
dim shared as double current_month
dim shared as double current_day
dim shared as string current_month_name
dim shared as string current_day_name
dim shared as double current_day_number
dim shared as double current_date
'========================================

dim shared as string generic_txt , str1
dim shared as string help_text

dim shared as double selected_year 
dim shared as double selected_month
dim shared as string selected_month_name
dim shared as double selected_day_number
dim shared as string selected_day_name

dim shared as string file

dim shared as byte startup=0

dim shared as double time1,time2
dim shared as integer time_toggle = 0

dim shared as integer time_slot_length


'run get date to set current month,day,year
get_current_date()

dim shared as integer yr_prev , yr_curr , yr_next
yr_prev = current_year-1
yr_curr = current_year
yr_next = current_year+1

dim shared as integer selected_period = 2

selected_month_name = current_month_name
selected_month      = current_month
selected_day_number = current_day_number
selected_day_name   = current_day_name
selected_year       = current_year

print "current  " ; current_month_name  , Current_day_number  , current_year  , current_day_name
print "selected " ;selected_month_name , selected_day_number , selected_year , selected_day_name

dim shared as integer agenda_length, agenda_rval , agenda_linenumber
dim shared as string  agenda_buffer, agenda_text
dim shared as integer toggle_edit = 0
'set up controls
'===============================================================================
'===============================================================================
Dim As MSG msg
Dim shared As HWND hWnd, JANUARY   , FEBUARY , MARCH    , APRIL                , _ 
                         MAY       , JUNE    , JULY     , AUGUST               , _
                         SEPTEMBER , OCTOBER , NOVEMBER , DECEMBER, date_time  , _
                         days1 , days2 , days3 , days4 , days5 , days6 , days7 , _
                         month_name , month_days(1 to 42) , _
                         period_1 , period_2 , period_3 , period_4 , period_5 , _
                         save_appointment , edit_appointment , _
                         holidays , holidays_txt  , _
                         daily_agenda , daily_agenda_txt , daily_agenda_info , _
                         year_prev , year_curr , year_next
' Create window
hWnd = CreateWindowEx( 0, "#32770", "Calendar version 1.0 by Albert Redditt Jan,2011", WS_OVERLAPPEDWINDOW Or WS_VISIBLE , 100, 100, 1024, 600, 0, 0, 0, 0 )

' current month/day/year and time
date_time = CreateWindowEx( 0, "EDIT"  , ""  , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY , 10, 10, 350, 30, hWnd, 0, 0, 0 )

' Create month buttons
JANUARY   = CreateWindowEx( 0, "BUTTON", "January"   , WS_VISIBLE Or WS_CHILD,  10, 50 , 80, 30, hWnd, 0, 0, 0 )
FEBUARY   = CreateWindowEx( 0, "BUTTON", "Febuary"   , WS_VISIBLE Or WS_CHILD, 100, 50 , 80, 30, hWnd, 0, 0, 0 )
MARCH     = CreateWindowEx( 0, "BUTTON", "March"     , WS_VISIBLE Or WS_CHILD, 190, 50 , 80, 30, hWnd, 0, 0, 0 )
APRIL     = CreateWindowEx( 0, "BUTTON", "April"     , WS_VISIBLE Or WS_CHILD, 280, 50 , 80, 30, hWnd, 0, 0, 0 )

MAY       = CreateWindowEx( 0, "BUTTON", "May"       , WS_VISIBLE Or WS_CHILD,  10, 90 , 80, 30, hWnd, 0, 0, 0 )
JUNE      = CreateWindowEx( 0, "BUTTON", "June"      , WS_VISIBLE Or WS_CHILD, 100, 90 , 80, 30, hWnd, 0, 0, 0 )
JULY      = CreateWindowEx( 0, "BUTTON", "July"      , WS_VISIBLE Or WS_CHILD, 190, 90 , 80, 30, hWnd, 0, 0, 0 )
AUGUST    = CreateWindowEx( 0, "BUTTON", "August"    , WS_VISIBLE Or WS_CHILD, 280, 90 , 80, 30, hWnd, 0, 0, 0 )

SEPTEMBER = CreateWindowEx( 0, "BUTTON", "September" , WS_VISIBLE Or WS_CHILD,  10,130 , 80, 30, hWnd, 0, 0, 0 )
OCTOBER   = CreateWindowEx( 0, "BUTTON", "October"   , WS_VISIBLE Or WS_CHILD, 100,130 , 80, 30, hWnd, 0, 0, 0 )
NOVEMBER  = CreateWindowEx( 0, "BUTTON", "November"  , WS_VISIBLE Or WS_CHILD, 190,130 , 80, 30, hWnd, 0, 0, 0 )
DECEMBER  = CreateWindowEx( 0, "BUTTON", "December"  , WS_VISIBLE Or WS_CHILD, 280,130 , 80, 30, hWnd, 0, 0, 0 )

'disabled day button indicators
Days1     = CreateWindowEx( 0, "BUTTON"  , "S"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD , 50,200, 30, 30, hWnd, 0, 0, 0 )
Days2     = CreateWindowEx( 0, "BUTTON"  , "M"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD , 90,200, 30, 30, hWnd, 0, 0, 0 )
Days3     = CreateWindowEx( 0, "BUTTON"  , "T"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,130,200, 30, 30, hWnd, 0, 0, 0 )
Days4     = CreateWindowEx( 0, "BUTTON"  , "W"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,170,200, 30, 30, hWnd, 0, 0, 0 )
Days5     = CreateWindowEx( 0, "BUTTON"  , "T"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,210,200, 30, 30, hWnd, 0, 0, 0 )
Days6     = CreateWindowEx( 0, "BUTTON"  , "F"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,250,200, 30, 30, hWnd, 0, 0, 0 )
Days7     = CreateWindowEx( 0, "BUTTON"  , "S"         , WS_BORDER Or WS_VISIBLE Or WS_CHILD ,290,200, 30, 30, hWnd, 0, 0, 0 )

'month name header
month_name = CreateWindowEx( 0, "EDIT"  , "_MONTHS_" , WS_BORDER Or WS_VISIBLE Or WS_CHILD OR ES_READONLY,35,165,300, 30, hWnd, 0, 0, 0 )

'individual days
month_days(1)  = CreateWindowEx( 0, "BUTTON", "1"         , WS_VISIBLE Or WS_CHILD,  50,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(2)  = CreateWindowEx( 0, "BUTTON", "2"         , WS_VISIBLE Or WS_CHILD,  90,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(3)  = CreateWindowEx( 0, "BUTTON", "3"         , WS_VISIBLE Or WS_CHILD, 130,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(4)  = CreateWindowEx( 0, "BUTTON", "4"         , WS_VISIBLE Or WS_CHILD, 170,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(5)  = CreateWindowEx( 0, "BUTTON", "5"         , WS_VISIBLE Or WS_CHILD, 210,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(6)  = CreateWindowEx( 0, "BUTTON", "6"         , WS_VISIBLE Or WS_CHILD, 250,240 , 30, 25, hWnd, 0, 0, 0 )
month_days(7)  = CreateWindowEx( 0, "BUTTON", "7"         , WS_VISIBLE Or WS_CHILD, 290,240 , 30, 25, hWnd, 0, 0, 0 )

month_days(8)  = CreateWindowEx( 0, "BUTTON", "8"         , WS_VISIBLE Or WS_CHILD,  50,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(9)  = CreateWindowEx( 0, "BUTTON", "9"         , WS_VISIBLE Or WS_CHILD,  90,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(10) = CreateWindowEx( 0, "BUTTON", "10"        , WS_VISIBLE Or WS_CHILD, 130,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(11) = CreateWindowEx( 0, "BUTTON", "11"        , WS_VISIBLE Or WS_CHILD, 170,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(12) = CreateWindowEx( 0, "BUTTON", "12"        , WS_VISIBLE Or WS_CHILD, 210,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(13) = CreateWindowEx( 0, "BUTTON", "13"        , WS_VISIBLE Or WS_CHILD, 250,270 , 30, 25, hWnd, 0, 0, 0 )
month_days(14) = CreateWindowEx( 0, "BUTTON", "14"        , WS_VISIBLE Or WS_CHILD, 290,270 , 30, 25, hWnd, 0, 0, 0 )

month_days(15) = CreateWindowEx( 0, "BUTTON", "15"        , WS_VISIBLE Or WS_CHILD,  50,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(16) = CreateWindowEx( 0, "BUTTON", "16"        , WS_VISIBLE Or WS_CHILD,  90,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(17) = CreateWindowEx( 0, "BUTTON", "17"        , WS_VISIBLE Or WS_CHILD, 130,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(18) = CreateWindowEx( 0, "BUTTON", "18"        , WS_VISIBLE Or WS_CHILD, 170,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(19) = CreateWindowEx( 0, "BUTTON", "19"        , WS_VISIBLE Or WS_CHILD, 210,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(20) = CreateWindowEx( 0, "BUTTON", "20"        , WS_VISIBLE Or WS_CHILD, 250,300 , 30, 25, hWnd, 0, 0, 0 )
month_days(21) = CreateWindowEx( 0, "BUTTON", "21"        , WS_VISIBLE Or WS_CHILD, 290,300 , 30, 25, hWnd, 0, 0, 0 )

month_days(22) = CreateWindowEx( 0, "BUTTON", "22"        , WS_VISIBLE Or WS_CHILD,  50,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(23) = CreateWindowEx( 0, "BUTTON", "23"        , WS_VISIBLE Or WS_CHILD,  90,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(24) = CreateWindowEx( 0, "BUTTON", "24"        , WS_VISIBLE Or WS_CHILD, 130,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(25) = CreateWindowEx( 0, "BUTTON", "25"        , WS_VISIBLE Or WS_CHILD, 170,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(26) = CreateWindowEx( 0, "BUTTON", "26"        , WS_VISIBLE Or WS_CHILD, 210,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(27) = CreateWindowEx( 0, "BUTTON", "27"        , WS_VISIBLE Or WS_CHILD, 250,330 , 30, 25, hWnd, 0, 0, 0 )
month_days(28) = CreateWindowEx( 0, "BUTTON", "28"        , WS_VISIBLE Or WS_CHILD, 290,330 , 30, 25, hWnd, 0, 0, 0 )

month_days(29) = CreateWindowEx( 0, "BUTTON", "29"        , WS_VISIBLE Or WS_CHILD,  50,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(30) = CreateWindowEx( 0, "BUTTON", "30"        , WS_VISIBLE Or WS_CHILD,  90,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(31) = CreateWindowEx( 0, "BUTTON", "31"        , WS_VISIBLE Or WS_CHILD, 130,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(32) = CreateWindowEx( 0, "BUTTON", "32"        , WS_VISIBLE Or WS_CHILD, 170,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(33) = CreateWindowEx( 0, "BUTTON", "33"        , WS_VISIBLE Or WS_CHILD, 210,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(34) = CreateWindowEx( 0, "BUTTON", "34"        , WS_VISIBLE Or WS_CHILD, 250,360 , 30, 25, hWnd, 0, 0, 0 )
month_days(35) = CreateWindowEx( 0, "BUTTON", "35"        , WS_VISIBLE Or WS_CHILD, 290,360 , 30, 25, hWnd, 0, 0, 0 )

month_days(36) = CreateWindowEx( 0, "BUTTON", "36"        , WS_VISIBLE Or WS_CHILD,  50,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(37) = CreateWindowEx( 0, "BUTTON", "37"        , WS_VISIBLE Or WS_CHILD,  90,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(38) = CreateWindowEx( 0, "BUTTON", "38"        , WS_VISIBLE Or WS_CHILD, 130,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(39) = CreateWindowEx( 0, "BUTTON", "39"        , WS_VISIBLE Or WS_CHILD, 170,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(40) = CreateWindowEx( 0, "BUTTON", "40"        , WS_VISIBLE Or WS_CHILD, 210,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(41) = CreateWindowEx( 0, "BUTTON", "41"        , WS_VISIBLE Or WS_CHILD, 250,390 , 30, 25, hWnd, 0, 0, 0 )
month_days(42) = CreateWindowEx( 0, "BUTTON", "42"        , WS_VISIBLE Or WS_CHILD, 290,390 , 30, 25, hWnd, 0, 0, 0 )

period_1 = CreateWindowEx( 0, "EDIT"  , "00:00" + chr(13)+chr(10) + "09:00" , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_MULTILINE or ES_READONLY ,630,10,65, 40, hWnd, 0, 0, 0 )
period_2 = CreateWindowEx( 0, "EDIT"  , "09:00" + chr(13)+chr(10) + "12:00" , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_MULTILINE or ES_READONLY ,700,10,65, 40, hWnd, 0, 0, 0 )
period_3 = CreateWindowEx( 0, "EDIT"  , "12:00" + chr(13)+chr(10) + "13:00" , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_MULTILINE or ES_READONLY ,770,10,65, 40, hWnd, 0, 0, 0 )
period_4 = CreateWindowEx( 0, "EDIT"  , "13:00" + chr(13)+chr(10) + "17:00" , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_MULTILINE or ES_READONLY ,840,10,65, 40, hWnd, 0, 0, 0 )
period_5 = CreateWindowEx( 0, "EDIT"  , "17:00" + chr(13)+chr(10) + "24:00" , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_MULTILINE or ES_READONLY ,910,10,65, 40, hWnd, 0, 0, 0 )

year_prev  = CreateWindowEx( 0, "BUTTON"  , str(yr_prev) , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_READONLY ,390,10,65, 25, hWnd, 0, 0, 0 )
year_curr  = CreateWindowEx( 0, "BUTTON"  , str(yr_curr) , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_READONLY ,475,10,65, 25, hWnd, 0, 0, 0 )
year_next  = CreateWindowEx( 0, "BUTTON"  , str(yr_next) , WS_BORDER Or WS_VISIBLE Or WS_CHILD or ES_READONLY ,555,10,65, 25, hWnd, 0, 0, 0 )

holidays     = CreateWindowEx( 0, "EDIT"  ,  space(2)+"!!~~ HOLIDAYS AND DAYS-OFF ~~!!" , _
                                 WS_BORDER Or _
                                 WS_VISIBLE Or _
                                 WS_CHILD   OR _
                                 ES_READONLY , _
                                 390, 50, 230, 30, hWnd, 0, 0, 0 )
holidays_txt = CreateWindowEx( 0, "EDIT"  ,  ""                                   , _
                                 WS_border Or _
                                 _ 'WS_VISIBLE Or _
                                WS_CHILD Or   _
                                 WS_HSCROLL Or _
                                 WS_VSCROLL Or _
                                 ES_AUTOHSCROLL Or _
                                 ES_AUTOVSCROLL Or _
                                 ES_MULTILINE, _
                                 390,130, 360, 330, hWnd, 0, 0, 0 )

daily_agenda  = CreateWindowEx( 0, "EDIT"  ,  space(2)+"!!~~        DAILY AGENDA          ~~!!" , _
                                 WS_BORDER Or _
                                 WS_VISIBLE Or _
                                 WS_CHILD   OR _
                                 ES_READONLY , _
                                 390, 90, 230, 30, hWnd, 0, 0, 0 )
daily_agenda_txt = CreateWindowEx( 0, "EDIT"  ,  ""                                   , _
                                 WS_border Or _
                                 _ 'WS_VISIBLE Or _
                                 WS_CHILD Or   _
                                 WS_HSCROLL Or _
                                 WS_VSCROLL Or _
                                 ES_AUTOHSCROLL Or _
                                 ES_AUTOVSCROLL Or _
                                 ES_MULTILINE or  _
                                 ES_READONLY , _
                                390, 130, 600, 330, hWnd, 0, 0, 0 )

daily_agenda_info = CreateWindowEx( 0, "BUTTON", "INFO" , WS_VISIBLE Or WS_CHILD, 640, 90 ,100, 30, hWnd, 0, 0, 0 )


save_appointment = CreateWindowEx( 1, "BUTTON"  ,  help_text, WS_CHILD or WS_VISIBLE , 50,  440,  300,  30, hWnd, 0, 0, 0 )
edit_appointment = CreateWindowEx( 1, "EDIT"    ,  ""       , WS_CHILD or WS_VISIBLE , 50,  470,  950,  30, hWnd, 0, 0, 0 )


static as HFONT hfont
hfont = MakeFont( "SansSerif", 12, FW_NORMAL, 0 )

SendMessage(daily_agenda_txt  ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(daily_agenda      ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(daily_agenda_info ,WM_SETFONT,cast(WPARAM, hFont),true)

SendMessage(holidays     ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(holidays_txt ,WM_SETFONT,cast(WPARAM, hFont),true)

SendMessage(date_time    ,WM_SETFONT,cast(WPARAM, hFont),true)

SendMessage(JANUARY   ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(FEBUARY   ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(MARCH     ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(APRIL     ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(MAY       ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(JUNE      ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(JULY      ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(AUGUST    ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(SEPTEMBER ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(OCTOBER   ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(NOVEMBER  ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(DECEMBER  ,WM_SETFONT,cast(WPARAM, hFont),true)

SendMessage(month_name ,WM_SETFONT,cast(WPARAM, hFont),true)

SendMessage(period_1 ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(period_2 ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(period_3 ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(period_4 ,WM_SETFONT,cast(WPARAM, hFont),true)
SendMessage(period_5 ,WM_SETFONT,cast(WPARAM, hFont),true)
'===============================================================================
'===============================================================================
'begin message loop
'===============================================================================
'===============================================================================
While GetMessage( @msg, 0, 0, 0 )
    TranslateMessage( @msg )
    DispatchMessage( @msg )
    
    if time_toggle = 0 then 
        time1 = timer
        time_toggle = 1
    end if
    
    if time_toggle=1 then 
        time2 = timer
        if time2> time1+.25 then
            update_time_and_date()
            time_toggle = 0
        end if
    end if

    
    if startup=0 then 
        startup=1
        start_up()
        load_work_times()
        load_holidays()
        load_appointments()
    end if
  
    Select Case msg.hwnd
        Case hWnd
        Select Case msg.message
            Case 273
            End
        End Select
      
    case period_1
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_period = 1
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select
        
    case period_2
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_period = 2
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select
    
    case period_3
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_period = 3
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select
    
    case period_4
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_period = 4
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select
    
    case period_5
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_period = 5
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select

    case year_prev
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_year = current_year-1
                start_up()
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
                SetWindowText(holidays_txt, "")
                load_holidays()
        end select
        
    case year_curr
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_year = current_year
                start_up()
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
                SetWindowText(holidays_txt, "")
                load_holidays()
        end select
    
    case year_next
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_year = current_year+1
                start_up()
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
                SetWindowText(holidays_txt,"")
                load_holidays()
        end select

    'get month selection
    Case JANUARY
        select case msg.message  
            Case WM_LBUTTONDOWN
                month1() : selected_month=1 : selected_month_name = "JANUARY"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select
    
    Case FEBUARY
        select case msg.message  
            Case WM_LBUTTONDOWN
                month2(): selected_month=2 : selected_month_name = "FEBUARY"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
        end select
    
    Case MARCH
        select case msg.message  
            Case WM_LBUTTONDOWN
                month3(): selected_month=3 : selected_month_name = "MARCH"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select
    
    Case APRIL
        select case msg.message  
            Case WM_LBUTTONDOWN
                month4(): selected_month=4 : selected_month_name = "APRIL"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )

                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select
    
    Case MAY
      select case msg.message  
            Case WM_LBUTTONDOWN
                month5(): selected_month=5 : selected_month_name = "MAY"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )

                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case JUNE
        select case msg.message  
            Case WM_LBUTTONDOWN
                month6(): selected_month=6 : selected_month_name = "JUNE"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case JULY
        select case msg.message  
            Case WM_LBUTTONDOWN
                month7(): selected_month=7 : selected_month_name = "JULY"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case AUGUST
        select case msg.message  
            Case WM_LBUTTONDOWN
                month8(): selected_month=8 : selected_month_name = "AUGUST"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case SEPTEMBER
        select case msg.message  
            Case WM_LBUTTONDOWN
                month9(): selected_month=9 : selected_month_name = "SEPTEMBER"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case OCTOBER
        select case msg.message  
            Case WM_LBUTTONDOWN
                month10() : selected_month=10 : selected_month_name = "OCTOBER"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case NOVEMBER
        select case msg.message  
            Case WM_LBUTTONDOWN
                month11() : selected_month=11 : selected_month_name = "NOVEMBER"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select

    Case DECEMBER
        select case msg.message  
            Case WM_LBUTTONDOWN
                month12() : selected_month=12 : selected_month_name = "DECEMBER"
                generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
                generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
                SetWindowText(month_name, generic_txt )
                SetWindowText(daily_agenda , space(2)+"!!~~        DAILY AGENDA          ~~!!" )
                SetWindowText(daily_agenda_txt , "")
                load_agenda()
            end select
    
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
''PART 2 
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
    'get individual calendar days selection week 1
    Case month_days(1)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(1), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(2)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(2), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(3)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(3), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(4)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(4), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
          end select

    Case month_days(5)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(5), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(6)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(6), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(7)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(7), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(8)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(8), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(9)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(9), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(10)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(10), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(11)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(11), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(12)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(12), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(13)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(13), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(14)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(14), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    'get individual calendar days selection week 3
    Case month_days(15)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(15), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(16)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(16), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(17)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(17), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(18)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(18), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(19)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(19), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(20)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(20), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(21)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(21), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    'get individual calendar days selection week 4
    Case month_days(22)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(22), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(23)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(23), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(24)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(24), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(25)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(25), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(26)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(26), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(27)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(27), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(28)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(28), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    'get individual calendar days selection week 5
    Case month_days(29)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(29), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(30)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(30), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(31)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(31), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(32)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(32), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(33)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(33), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(34)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(34), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(35)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(35), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    'get individual calendar days selection week 6
    Case month_days(36)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(36), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
            
    Case month_days(37)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(37), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    Case month_days(38)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(38), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(39)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(39), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(40)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(40), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(41)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(41), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select

    Case month_days(42)
        select case msg.message  
            Case WM_LBUTTONDOWN
                selected_day_number = 0
                generic_txt = "   "
                GetWindowText(month_days(42), generic_txt , 4)
                generic_txt = trim(generic_txt," ")
                if len(generic_txt)>=1 then 
                    selected_day_number=val(generic_txt)
                    load_agenda()
                end if
            end select
    
    case holidays
        select case msg.message
        case WM_RBUTTONDOWN
                dim as hWnd holiday 
                help_text = "To alter the Holidays / Days Off " +chr(13)+chr(10)
                help_text+= "Run Calendar_Init.                " +chr(13)+chr(10)
                holiday = CreateWindowEx( 0, "EDIT", "HOLIDAY INSTRUCTIONS", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 800, 480, 0, 0, 0, 0 )
                SetWindowText(holiday,help_text)
        case WM_LBUTTONDOWN
             ShowWindow(daily_agenda_txt, SW_HIDE)
             ShowWindow(holidays_txt    , SW_SHOW)
            end select
    
    case daily_agenda
        select case msg.message
        case WM_RBUTTONDOWN
                dim as hWnd dailys 
                help_text = "Enter a Time 'Hours' : 'Minutes'   " +chr(13)+chr(10)
                help_text+= "example:                           " +chr(13)+chr(10)
                help_text+= "12:00 lunch                        " +chr(13)+chr(10)
                help_text+= "                                   " +chr(13)+chr(10)
                help_text+= "You can type in up to 80 characters for time_slot notes." +chr(13)+chr(10)
                dailys = CreateWindowEx( 0, "EDIT", "DAILY AGENDA INSTRUCTIONS", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 800, 480, 0, 0, 0, 0 )
                SetWindowText(dailys,help_text)
        case WM_LBUTTONDOWN
             ShowWindow(holidays_txt    , SW_HIDE)
             ShowWindow(daily_agenda_txt, SW_SHOW)
             load_agenda()
        end select
    
    case daily_agenda_info
        select case msg.message
            case WM_LBUTTONDOWN
                dim as hWnd agenda_info
                    help_text = "Left Click on 'Holidays and days off' to view years holidays." +chr(13)+chr(10)
                    help_text+= "Left click on 'Daily Agenda' to view the days time-slots.    " +chr(13)+chr(10)
                    help_text+= "                                                    " +chr(13)+chr(10)
                    help_text+= "Click on a time-slot at the top right of the window." +chr(13)+chr(10)
                    help_text+= "To view the appointment times for that time-slot.   " +chr(13)+chr(10)
                    help_text+= "                                                    " +chr(13)+chr(10)
                    help_text+= "After clicking on 'Daily Agenda' doubleclick on a linenumber to the left of the agenda." +chr(13)+chr(10)
                    help_text+= "The entry feild is below to the left at the bottom of the window. " +chr(13)+chr(10)
                    help_text+= "Enter you appointment data up to 80 characters it will be truncated at 80. " +chr(13)+chr(10)
                    help_text+= "Then Click on the time-date button above the entry feild. " +chr(13)+chr(10)
                    agenda_info = CreateWindowEx( 0, "EDIT", "Operation Info", WS_OVERLAPPEDWINDOW Or WS_VISIBLE or ES_MULTILINE , 100, 100, 800, 480, 0, 0, 0, 0 )
                    SetWindowText(agenda_info,help_text)
        end select
    case daily_agenda_txt
        select case msg.message
            case WM_LBUTTONDBLCLK
                agenda_length = GetWindowTextLength( daily_agenda_txt ) + 1
                agenda_buffer = space( agenda_length )
                GetWindowText(daily_agenda_txt, strptr(agenda_buffer) , agenda_length )
                agenda_rval = SendMessage( daily_agenda_txt, EM_GETSEL, 0, 0 )
                agenda_text = mid( agenda_buffer, loword(agenda_rval) + 1, 111)' hiword(agenda_rval) - loword(agenda_rval) )
                help_text = left(agenda_text,29)
                agenda_linenumber = val(left(help_text,4))
                
                SetWindowText(save_appointment,help_text)
                SetWindowText(edit_appointment, "" )
                toggle_edit = 1
        end select
    
    case save_appointment
        select case msg.message
            case WM_LBUTTONDOWN
                if toggle_edit = 1 then
                    agenda_length = GetWindowTextLength( edit_appointment ) + 1
                    agenda_buffer = space(agenda_length )
                    GetWindowText( edit_appointment, strptr(agenda_buffer) , agenda_length )
                    agenda_buffer = trim(agenda_buffer," ")
                    agenda_buffer = agenda_buffer + string(111,"_")
                    agenda_buffer = help_text + agenda_buffer
                    agenda_buffer = left(agenda_buffer ,109 ) + chr(13)+chr(10)
                
                    file = curdir + "\" + str(selected_year) + "\" + left(selected_month_name,3)+"\" + left(selected_month_name,3)+"_DATABASE.TXT"
                
                    if fileExists(file) then
                        open file for binary as #1
                            seek #1 , ((agenda_linenumber*111)-110)
                            put #1, , agenda_buffer
                        close #1
                        load_agenda()
                    end if
                    toggle_edit=0
                end if
                
        end select
    End select
        
Wend
'*******************************************************************************
'*******************************************************************************
END ' of program
'*******************************************************************************
'*******************************************************************************
sub get_current_date()
    current_year  = (val(right(date,4  )))
    current_month = (val(left (date,2  )))
    current_day   = (val(mid  (date,4,2)))

    current_date = DateSerial(current_year,current_month,current_day)
    
    current_day_name   = ucase( WeekDayName(WeekDay( current_date )))
    current_month_name = Ucase(MONTHNAME(MONTH( current_date )))
    current_day_number = DAY( current_date )
    current_year       = year( current_date )

end sub
'===============================================================================
'===============================================================================
sub get_selected_date()
    dim as double selected_date
    
    selected_date = DateSerial(selected_year,selected_month,selected_day_number)
    
    selected_day_name   = ucase( WeekDayName(WeekDay( selected_date )))
    selected_month_name = Ucase(MONTHNAME(MONTH( selected_date )))
    selected_day_number = DAY( selected_date )
    selected_year       = year(selected_date )
    
    print selected_day_name , selected_month_name , selected_day_number , selected_year

end sub
'===============================================================================
'===============================================================================
sub start_up()
    select case selected_month
        case 1  
            month1()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
            
        case 2  
            month2()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
            
        case 3  
            month3()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 4  
            month4()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 5  
            month5()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 6  
            month6()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 7  
            month7()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 8  
            month8()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 9  
            month9()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)

        case 10 
            month10()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 11 
            month11()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
        
        case 12 
            month12()
            generic_txt = string(60," ") + selected_month_name + "   " + str(selected_year) + string(60," ")
            generic_txt = mid(generic_txt , len(generic_txt)/3-5 , len(generic_txt)/2)
            SetWindowText(month_name, generic_txt)
    
    end select

end sub
'===============================================================================
'===============================================================================
sub load_work_times()
    
    dim day_txt          as string
    dim start_txt        as string
    dim lunch_start_txt  as string
    dim lunch_finish_txt as string
    dim finish_txt       as string
    
    dim per_1 as string
    dim per_2 as string
    dim per_3 as string
    dim per_4 as string
    dim per_5 as string
    
    file=curdir+"\"+ str(selected_year) + "\Work_Times.ini"
    if FileExists(file) then
        open file for input as #1
            do
                line input #1, day_txt
                line input #1, start_txt
                line input #1, lunch_start_txt
                line input #1, lunch_finish_txt
                line input #1, finish_txt
                print day_txt + " " , start_txt , lunch_start_txt , lunch_finish_txt , finish_txt
            
            loop until day_txt = current_day_name
                
            SetWindowText(period_1    , "00:00"          +chr(13)+chr(10) + start_txt        ) 
            SetWindowText(period_2    , start_txt        +chr(13)+chr(10) + lunch_start_txt  )
            SetWindowText(period_3    , lunch_start_txt  +chr(13)+chr(10) + lunch_finish_txt )
            SetWindowText(period_4    , lunch_finish_txt +chr(13)+chr(10) + finish_txt       )
            SetWindowText(period_5    , finish_txt       +chr(13)+chr(10) + "24:00"          )
            
        close #1
    end if
end sub

'===============================================================================
'===============================================================================
sub load_holidays()
        
    file=curdir+"\"+ str(selected_year) + "\Holidays.ini"
    if FileExists(file) then
        open file for input as #1
            str1=""
            do    
                line input #1,generic_txt
                str1+=generic_txt + chr(13)+chr(10)
            loop until eof(1)
            SetWindowText(holidays_txt,str1)
        close #1
    end if
    
    str1=""
    generic_txt=""
    parse_holidays()
end sub
'===============================================================================
'===============================================================================
sub load_appointments()
    
    file=curdir+ "\Appointments.ini"
    if fileexists(file) then 
        open file for input as #1
            line input #1,generic_txt
            time_slot_length = val(trim(generic_txt," "))
        close #1
    else
        messagebox(0,"Run Calendar_init to initialize calendar year" , 0 , MB_OK)
    end if
    
end sub

'===============================================================================
'===============================================================================
sub load_agenda()
    
    dim as string *2 hrs,mins
    
    dim as string dates
    
    dim per_h_1    as string *2
    dim per_m_1    as string *2
    
    dim per_h_2    as string *2
    dim per_m_2    as string *2
    
    dim as string *5 st1,st2
    
    select case selected_period
        case 1
            generic_txt = string(30," ")
            GetWindowText(period_1 , generic_txt , 30 )
            generic_txt=trim(generic_txt," ")
        case 2
            generic_txt = string(30," ")
            GetWindowText(period_2 , generic_txt , 30 )
            generic_txt=trim(generic_txt," ")
        case 3
            generic_txt = string(30," ")
            GetWindowText(period_3 , generic_txt , 30 )
            generic_txt=trim(generic_txt," ")
        case 4
            generic_txt = string(30," ")
            GetWindowText(period_4 , generic_txt , 30 )
            generic_txt=trim(generic_txt," ")
        case 5
            generic_txt = string(30," ")
            GetWindowText(period_5 , generic_txt , 30 )
            generic_txt=trim(generic_txt," ")
    end select
    
    st1=left(generic_txt,5)
    per_h_1    = left(st1  ,2)
    per_m_1    =  mid(st1,4,2)

    st2=right(generic_txt,5)
    per_h_2    = left(st2  ,2)
    per_m_2    =  mid(st2,4,2)
    
    dim a as double
    dim dates_times as string
    
    get_selected_date()
    
    a=dateserial (selected_year, selected_month, selected_day_number)
    
    dates_times= ucase( WeekDayName(WeekDay(a))) + " " + Ucase(MONTHNAME(MONTH(a))) + " " + str(DAY(a)) + " " + str(year(a))
    
    SetWindowText( daily_agenda , dates_times )
    
    dates_times = curdir + "\" + str(selected_year) + "\" + left(selected_month_name,3)+ "\" + left(selected_month_name,3) + "_DATABASE.TXT"
    
    if not FileExists(dates_times) then
        MessageBox(0, "Run Calendar_Init.exe to Initialize  " + str(selected_year)+ " Calendar Year" ,0,MB_OK )
    end if
    
    dim info as string
    dim str1 as string
    dim times as string = left(selected_day_name,3)+"_"+left(selected_month_name,3)+"_"+ right("00"+str(selected_day_number),2)

    open dates_times for input as #1
        do
            line input #1 , info
                dates = mid(info,6,10)
                
                if dates=times then
                    
                    hrs  = mid(info,23,2)
                    mins = mid(info,26,2)
                    
                    if hrs+mins >= per_h_1+per_m_1  and  hrs+mins < per_h_2+per_m_2 then
                        str1+= info + chr(13) + chr(10)
                    end if
                end if   
        loop until eof(1)
    close #1
    SetWindowText( daily_agenda_txt , str1)
end sub
'===============================================================================
'===============================================================================
Sub parse_holidays()
    
    file=curdir+ "\" + str(selected_year) + "\Holidays.ini"
    open file for input as #1
    do
        line input #1,generic_txt
        print generic_txt
    loop until eof(1)
    
end sub
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'PART 3 line 1132
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
'===============================================================================
sub month1() 'jan
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 1 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month2()'feb
    dim as integer isleapyear=0
    
    dim first_day as integer
    dim last_day as integer = 28
    
    if selected_year Mod 4 = 0 And selected_year Mod 100 <> 0 Or (selected_year Mod 400 = 0) then isleapyear = 1

    if isleapyear then last_day=29
    
    dim a as double
    dim day_name as string
    
    a= DateSerial(selected_year, 2 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month3()'mar
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 3 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month4()'apr
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    dim day_name as string
    
    a= DateSerial(selected_year, 4 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
sub month5()'MAY
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 5 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month6()'jun
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    dim day_name as string
    
    a= DateSerial(selected_year, 6 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month7()'jul
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    dim day_name as string
    
    a= DateSerial(selected_year, 7 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month8()'aug
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 8 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
sub month9()'sep
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    dim day_name as string
    
    a= DateSerial(selected_year, 9 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month10()'oct
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 10 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month11()'nov
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 30
    dim day_name as string
    
    a= DateSerial(selected_year, 11 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'===============================================================================
'===============================================================================
sub month12()'dec
    dim a as double
    
    dim first_day as integer
    dim last_day as integer = 31
    dim day_name as string
    
    a= DateSerial(selected_year, 12 , 1 )
    day_name = WeekDayName(WeekDay(a))
    
    print "first day of month = " ; day_name
    
    select case day_name
        case "Sunday"    : first_day = 1
        case "Monday"    : first_day = 2
        case "Tuesday"   : first_day = 3
        case "Wednesday" : first_day = 4
        case "Thursday"  : first_day = 5
        case "Friday"    : first_day = 6
        case "Saturday"  : first_day = 7
    end select
    
    for inc1 as integer = 1 to 42 step 1
        SetWindowText(month_days(inc1),"")
    next
    
    for inc1 as integer = first_day to 42 step 1
        SetWindowText(month_days(inc1), str(inc1-first_day+1) )
        if inc1 > (last_day+first_day-1) then SetWindowText(month_days(inc1),"")
    next
    
end sub
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
sub update_time_and_date()

    dim as string time_12
    
    dim as string dates_times
    dim a as double
    
    get_current_date()
    
    a=dateserial (current_year, current_month , current_day)
    
    dates_times= ucase( WeekDayName(WeekDay(a))) + " " + Ucase(MONTHNAME(MONTH(a))) + " " + str(DAY(a)) + " " + str(year(a)) + "  " + time
    
    SetWindowText(date_time , dates_times )

end sub
'===============================================================================
'===============================================================================
